<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 Header("Location: login.php?redir=acct_features.php");
 exit;
}

$dbh = db_connect();

if ($_SERVER[REQUEST_METHOD] == "POST") {

	$reference_email = sanitize($_POST[reference_email]);

	foreach ($_POST as $key => $value) {
		if (strstr($key,"feature-")) {
			$tmparray = explode("-",$key);
			$feat = $tmparray[1];  
			$setting = $tmparray[2];
			$features[$feat][$setting] = $value;
	        } #End if
	}

	$db_query = "SELECT reference_email FROM users WHERE username = '$user'";
	$sth = pg_query($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	$db_reference_email = $result[0];

	if (isset($features[web])) {
		# Strip HTML tags on the user's description input
		$features[web][config] = strip_tags($features[web][config]);
	}
	if (isset($features[web_domain])) {
		# Do a web domain validation check.
		if (!is_valid_web_domain($features[web_domain][config],$user)) {
			# Remove the $features[web_domain] array.
			$body .= "Sorry, the web domain you entered does not appear to be valid or is already in use. Ignoring change.<br>\n";
			unset($features[web_domain]);
		}
	}

	$features_changed = set_features($user,$user,$features);

	if (count($features_changed) <= 0 && $db_reference_email == $reference_email) {
		$body .= "No Changes were made!\n";
	} elseif ($db_reference_email != $reference_email) {
		# Change the reference email address.
		$test_result = is_valid_email_addr($reference_email);
		if ($test_result[0]) {
			$db_query = "UPDATE users SET reference_email = '$reference_email' WHERE username = '$user' AND reference_email = '$db_reference_email'";
			$sth = pg_query($dbh,$db_query);
			$body .= "Your reference email address has been updated!<br>\n";
		} else {
			$body .= "Sorry, the email address you entered does not appear to be valid ($test_result[1]). Ignoring change.<br>\n";
		}
	} else {
		# Display a list of feature changes.
		foreach ($features_changed as $key => $value) {
			$body .= "Updating feature \"<b>$key</b>\".<br>\n";
		}
		$body .= "Please wait for your feature changes to complete before making 
			any more changes to your account. You can monitor the status of
			your changes on the <a href='pending_tasks.php'>Pending Tasks</a>
			page.\n";
	}


$body .= "<br><br>\n";
} #End if server request method is POST
### Begin GET method
$db_query = "SELECT  realname,reference_email,last_known_ip,mail_checked,created,modified,account_class FROM users WHERE username = '$user'";
$sth = pg_query($dbh,$db_query);
$result = pg_fetch_row($sth,0);

$realname = $result[0];
$reference_email = $result[1];
$last_known_ip = $result[2];
$mail_checked = $result[3];
$created = $result[4];
$modified = $result[5];
$account_class = $result[6];

$n_created = nice_time($created);
$n_modified = nice_time($modified);
$n_mail_checked = nice_time($mail_checked);

$n_account_class = verbose_acctclass($account_class);

$features_default = get_features();
$features_user = get_features($user);
$features_notconfigured = array_diff_assoc($features_default,$features_user);

$body .= "<form method=\"POST\" action=\"acct_features.php\">
<table border=0 cellpadding=2 cellspacing=2 width=350>
<tr><td colspan=2 bgcolor=\"#333366\" align=center><b>Your Account</b></td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b>Username</b>&nbsp;</td>
	<td bgcolor=\"#181818\">$user</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b>Real Name</b>&nbsp;</td>
	<td bgcolor=\"#181818\">$realname</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b>Reference Email</b>&nbsp;</td>
	<td bgcolor=\"#181818\"><input type=\"text\" name=\"reference_email\" value=\"$reference_email\" size=32 maxlength=255></td></tr>

<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Home Directory</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">/vsn/home/$user</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Account Class</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">$n_account_class</td></tr>

<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Last IP</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">$last_known_ip</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Created</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">$n_created</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Modified</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">$n_modified</td></tr>
<tr><td bgcolor=\"#222222\" width=25% align=right><b><nobr>Messages Checked</nobr></b>&nbsp;</td>
	<td bgcolor=\"#181818\">$n_mail_checked</td></tr>
</table>\n";


$body .= "
<br><br>
<table border=0 cellpadding=2 cellspacing=2 width=350>
	<tr bgcolor=\"#333366\">
		<td>Feature</td>
		<td>Enabled</td>
		<td>Configuration</td>
		<td>Cost</td>
	</tr>\n";
$p = 0;

$featureslists = array("features_user","features_notconfigured");
foreach ($featureslists as $key => $featureslist) {
	foreach ($$featureslist as $feat_name => $feat_array) {
		$p++;
		is_int($p/2) ? $bgcolor = "#222222" : $bgcolor = "#181818";
		$en_selyes = "";
		$en_selno = "";
		$feat_array[enabled] == "t" ? $en_selyes = " selected" : $en_selno = " selected";
		$enabled_html = "<select name='feature-$feat_name-enabled'><option value='t'$en_selyes>Yes<option value='f'$en_selno>No</select>";
		if ($feat_array[config] != "0") {
			$config_html = "<input type='text' name='feature-$feat_name-config' value='$feat_array[config]' size=25 maxlength=255>";
		} else {
			$config_html = "N/A<input type='hidden' name='feature-$feat_name-config' value=\"$feat_array[config]\">";
		}
		if ($feat_name == "quota") {
			$enabled_html = "Yes";
			$config_html = $feat_array[config]." MB";
		}
		if ($feat_array[cost] == "0") {
			$cost_html = "Free";
		} else {
			$cost_html = "\$$feat_array[cost]/month";
		}
		$cost_html .= "<input type=\"hidden\" name=\"feature-$feat_name-cost\" value=\"$feat_array[cost]\">";	
		$body .= "\t<tr bgcolor=\"$bgcolor\">
			<td>$feat_name</td>
			<td>$enabled_html</td>
			<td>$config_html</td>
			<td>$cost_html</td>
		</tr>\n";
	} #End second foreach
} #End first foreach
$body .= "</table>\n
<br>
<input type='Submit' value='Make Changes'>
</form>
";

$pd = array(	user	=> "$user",
		page	=> "Account Features",
		title	=> "Account Features",
		body	=> "$body"
		);
write_page($pd);

?>
