#!/usr/bin/perl

###  Loading Requirements (equiv of C include)
require "lib/environment";
require "lib/utils";
&loadenv(%ENV);

###  Last Updated: 03/15/2000
###
###  This is mah Super CGI Template.
###
###  The last update added this errlog_updated scalar to see if an error has 
###  occurred. In fact, it reports the cumulative number of errors so far.

#$errlog_updated = 0;

print "Content-type:text/html\n\n";

# --------------------------------------------------------------------------

### First, load a list of users with html documents present into an array.

#@sites = `find /vsn/home -name ".description" | grep "public_html/.description"`;
@sites = `ls /vsn/home/*/public_html/.description`;


# Strip the unnecessary parts of the results, and save the user names
# to the "users" array".

foreach $site (@sites) {
	# Grab the 4th variable.
	($dump,$dump,$dump,$user,$dump,$dump) = split(/\//i,$site);
	if ($users[$#users] ne $user) {
		push(@users,$user);
	}
}
undef(@sites);

### Now, load up the virtual hosts data file.
# This file tells us if a user has a virtual domain for their site.

open(FILE,"/vsn/admin/vhosts/hosts.dat") or dienice("Could not open hosts.dat file to build domain information.");
@hosts = <FILE>;
close(FILE);

foreach $host (@hosts) {
	chomp($host);
	# If the file is a comment, ignore it. Otherwise, take the domain
	# name and store it in the subdomain hash, keyed by the username.
	if (substr($host,0,1) ne "#") {
		($type,$user,$domain) = split(/ /i,$host);
		$subdomain{$user} = $domain;
	}
}

###
# Grab the template file, print it out.
###

open(FILE,"templates/users.html") or dienice("Could not open template file.");
@fdata = <FILE>;
close(FILE);

foreach $line (@fdata) {
	$template .= $line;
}

($first,$last) = split(/<split>/i,$template);
print $first;
	&list_users;
print $last;

exit;

# --------------------------------------------------------------------------
# We are Officially All Done.
# --------------------------------------------------------------------------


###  Subroutines.

sub list_users {
	# Go through the array of users. Get their description.
	# Then print the appropriate link, based on if they have a subdomain
	# or not.
	foreach $user (@users) {
		$description = get_desc($user);
		if (defined($subdomain{$user})) {
			print "<a href=\"http://$subdomain{$user}/\" target=\"_new\">$user</a> - $description<br>\n";
		} else {
			print "<a href=\"/~$user/\" target=\"_new\">$user</a> - $description<br>\n";
		}
	#end foreach
	}
#End Sub
}

sub get_desc {
	my($user) = @_;

	# Read the description, use only the first 150 bytes.
	$desc = `cat ~$user/public_html/.description`;
	if (length($desc) > 150) {
		$desc = substr($desc,0,150);
	}

	#This loop removes HTML tags nicely
	while (index($desc,"<") > -1 && index($desc,">") > -1) {
		$first = index($desc,"<");
		$second = index($desc,">");
		$html_tag = substr($desc,$first,$second - $first + 1);
		$desc =~ s/$html_tag//g;
	}

	return $desc;
}
