#!/usr/bin/perl

use User::pwent;
use Crypt::PasswdMD5;
$0 = "kung fu ninja: checking passwords";

if ($ARGV[0] eq "-e") {
	#assume environment variable for password. username is argv[1]
	defined($ARGV[1]) ? $USERNAME = $ARGV[1] : exit 255;
	defined($ARGV[2]) ? $PW_ENV = $ARGV[2] : exit 255;

	defined($ENV{$PW_ENV}) ? $PASSWORD = $ENV{$PW_ENV} : exit 255;
	$PASSWORD =~ s/\n//g;

} elsif ($ARGV[0] eq "-s") {
	#assume using stdin for password. username is argv[1]
	defined($ARGV[1]) ? $USERNAME = $ARGV[1] : exit 255;
	$PW_STDIN = <STDIN>;
	($PASSWORD,@shit) = split(/\n/,$PW_STDIN);
	@shit = undef;

} elsif (!defined($ARGV[0]) || $ARGV[0] eq "") {
	#assume no args given. return error.
	&syntax;
	exit 255;
} else {
	#assume username/passwd are args
	defined($ARGV[0]) ? $USERNAME = $ARGV[0] : exit 255;
	defined($ARGV[1]) ? $PASSWORD = $ARGV[1] : exit 255;
}

# Quick password validation
if (length($PASSWORD) < 1) {
	exit 255;
}

## At this point, the USERNAME and PASSWORD variables are set.
## Detect if the password is cleartext, crypt, or md5.
## Note that a password that appears to be crypt might actually be cleartext.
## Keep this in mind when writing your functions and error handling.

if (substr($PASSWORD,0,3) eq "\$1\$") {
	$PW_TYPE = "md5";
} elsif (length($PASSWORD) == 13 && $PASSWORD =~ /^[a-zA-Z0-9]+$/) {
	$PW_TYPE = "crypt";
} else {
	$PW_TYPE = "cleartext";
}

## Now get their encrypted password from the db. Compare.
##$tmp0 = getpwnam($USERNAME);
##defined($$tmp0[1]) ? $DB_PASSWORD = $$tmp0[1] : exit 255;

#print "DEBUG: Preemptive runlevel is $?\n";
$DB_PASSWORD = `./getpw $USERNAME`;
#print "DEBUG: Returned $DB_PASSWORD\n";
if (!defined($DB_PASSWORD) || length($DB_PASSWORD) <= 1) {
	# Boo. hizz!
	exit 255;
}

if ($PW_TYPE eq "md5" || $PW_TYPE eq "crypt") {
	if ($PASSWORD eq $DB_PASSWORD && length($PASSWORD) >= 13) {
		print $PASSWORD;
		exit 0;
	} else {
		# fall back and try it as an unencrypted password.
		$PW_TYPE = "cleartext";
	}
}

if ($PW_TYPE eq "cleartext") {
	# First, detect if DB_PASSWORD is crypt or md5.
	if (substr($DB_PASSWORD,0,3) eq "\$1\$" && length($DB_PASSWORD) == 34) {
		# This is an md5 password.
		($nul,$nul,$salt,$nul) = split(/\$/i,$DB_PASSWORD);
		$crypt_pw = unix_md5_crypt($PASSWORD, $salt);
#print "DEBUG: cleartext is $PASSWORD with salt $salt results in $crypt_pw\n";
	#End if md5
	} elsif (length($DB_PASSWORD) == 13) {
		# Assume crypt password.
		$salt = substr($DB_PASSWORD,0,2);
		$crypt_pw = crypt($PASSWORD,$salt);
	} else {
		#This should never happen.
		print STDERR "ERROR: This should never happen. DB_PASSWORD is \"$DB_PASSWORD\"\n";
		exit 255;
	}

#print "DEBUG: Crypt pw: $crypt_pw\nDEBUG:  db pass: $DB_PASSWORD\n";
	# Now, actually behave based on the new crypted pw.
	if ($crypt_pw eq $DB_PASSWORD && length($crypt_pw) >= 13) {
		print $crypt_pw;
		exit 0;
	} else {
		# password mismatch
		exit 1;
	}

#End if pw_type is cleartext.
} else {
	# This condition should never happen.
	exit 255;
}

# Just in case.
exit 255;


sub syntax {
	$msg = <<EndOfMsg;

Syntax error. Correct syntax is:
\tcheckpw.pl -e username variable (reads password from environment variable
\tcheckpw.pl -s username (send password thru STDIN)
\tcheckpw.pl username password

EndOfMsg
	print $msg;
}

