<?
#auth.inc.php
#
# At the moment, we are storing and using cleartext pw's in the cookies.
# In the future, we want to use MD5 hashes to compare them to the passwords
# in the password database. of course, the password database needs to hold
# MD5 hashes as well.
#
###
# First things first. Define/connect to our cookie!
###
session_name("NetAdmin");
session_save_path("/usr/local/lib/php/sessions");
session_cache_expire(30);
session_start();
session_register("AUTH");

if (!isset($AUTH)) {
	$AUTH = array();
}
if ((!$AUTH[user]) or (!$AUTH[pass])) {
	go_login();
} else {
	if ($AUTH[user] && $AUTH[pass]) {
		$user = sanitize($AUTH[user]);
		$pass = sanitize($AUTH[pass]);
	}

	if (!authorized($user,$pass)) {
		go_login();
	}

#End if user & pass...
}

###
# Snazzy functions
###
function authorized($user,$pass) {
	$db_query = "SELECT password FROM users WHERE username = '$user'";

	$dbh = db_connect();
	$sth = pg_exec($dbh,$db_query);
	$rows = pg_numrows($sth);
	if ($rows > 1) {
		echo "Multiple matching accounts in <i>users</i> table for user $user. This is bad. Notify the system administrator.";
		return 0;
	} elseif ($rows < 1) {
		return 0;
	}

	$db_pass = pg_result($sth,0,"password");
	pg_close($dbh);

#	echo "DEBUG: pass from DB is $db_pass. actual pass is $pass<br>\n";
	if ($db_pass == $pass) {
		#It's valid! 
		# Now figure out his authorization level.
		#  If this is a system account, do NOT let them login!!!
		$authlevel = authlevel($user);
		if ($authlevel >= 8) {
			# This must be a system account or root. do not
			#  let anyone, under any circumstances, login as
			#  this account!
			return 0;
		} elseif ($authlevel) {
			return 1;
		}
	} else {
		# Password is bad. just say no.
		return 0;
	}
#End func authorized
}


function authlevel($user) {
	$dbh = db_connect();
	$db_query = "SELECT account_class FROM users WHERE username = '$user'";
	$sth = pg_exec($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	pg_close($dbh);
	$acct_bin = decbin($result[0]);

	while (strlen($acct_bin) < 9) {
		$acct_bin = "0".$acct_bin;
	}

	# There are only 9 bits in this binary number split into 9 
	# fields.
	$n = 0;
	while (strlen($acct_bin)) {
		$acct_rbits[$n] = intval(substr($acct_bin,0,1));		
		$acct_bin = substr($acct_bin,1);
		$n++;
	}

	# Play an endian game and reverse the order of this array.
	$acct_bits = array_reverse($acct_rbits);

	# A quick rehash of the binary offset used for account_class:
	#   1 = "user" (created by automated signup)
	#   2 = "paid" (a paying account)
	#   4 = "power-user" (friend of the staff)
	#   8 = "idle-exempt" (does not get checked for being an idle account)
	#  16 = ??
	#  32 = ??
	#  64 = "staff" (staff member)
	# 128 = "system" (system account - like nobody or qmailr)
	# 256 = "root" (may not be necessary, but who knows?)
	# 
	# In the conditions below, return the number one-higher than
	#  the array index. reason being, index 0 points to bit 1.
	#  comprende?
	#

	if ($acct_bits[8]) {
		# root. We should log this. ack.
		return 0;
	} elseif ($acct_bits[7]) {
		# system. We shhuld log this too. less ack.
		return 0;
	} elseif ($acct_bits[6]) {
		# Cool - we got a staff member.
		return 7;
	} elseif ($acct_bits[1]) {
		# Looks like a paid user.
		return 2;
	} elseif ($acct_bits[0]) {
		# Looks like a free user.
		return 1;
	} else {
		# these people have no permissions? shrug.
		return 0;
	}
# End function.
}

?>
