<?
#inc.auth.php
#
# At the moment, we are storing and using cleartext pw's in the cookies.
# In the future, we want to use MD5 hashes to compare them to the passwords
# in the password database. of course, the password database needs to hold
# MD5 hashes as well.
#
###
# First things first. Define/connect to our cookie!
###
session_name("VectorStar");
session_save_path("/usr/local/lib/php/sessions");
session_cache_expire(30);
session_start();
session_register("AUTH");

if (!isset($AUTH)) {
	$AUTH = array();
}
if ((!$AUTH[user]) or (!$AUTH[pass])) {
###	go_login();
} else {
	if ($AUTH[user] && $AUTH[pass]) {
		$user = sanitize($AUTH[user]);
		$pass = sanitize($AUTH[pass]);
	}

	$authset = authorized($user,$pass);
###	if (!$authset[0]) {
###		go_login();
###	}
	$AUTH[pass] = $authset[1];

#End if user & pass...
}

###
# Snazzy functions
###
function authorized($user,$pass) {

	putenv("pw_$user=$pass");
	$db_pass = `./checkpw.pl -e $user pw_$user`;

	if (strlen($db_pass) > 3) {
		#It's valid! 
		# Now figure out his authorization level.
		#  If this is a system account, do NOT let them login!!!
		$authlevel = authlevel($user);
		if ($authlevel >= 8) {
			# This must be a system account or root. do not
			#  let anyone, under any circumstances, login as
			#  this account!
			return array("0","");
		} elseif ($authlevel > 0) {
			return array("1",$db_pass);
		}
	} else {
		# Password is bad. just say no.
		return array("0","");
	}
#End func authorized
}

function authlevel($user) {
	$inc_dbh = db_connect();
	$db_query = "SELECT account_class FROM users WHERE username = '$user'";
	$sth = pg_query($inc_dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	pg_close($inc_dbh);
	$acct_bin = decbin($result[0]);

	while (strlen($acct_bin) < 9) {
		$acct_bin = "0".$acct_bin;
	}

	# There are only 9 bits in this binary number split into 9 
	# fields.
	$n = 0;
	while (strlen($acct_bin)) {
		$acct_rbits[$n] = intval(substr($acct_bin,0,1));		
		$acct_bin = substr($acct_bin,1);
		$n++;
	}

	# Play an endian game and reverse the order of this array.
	$acct_bits = array_reverse($acct_rbits);

	# A quick rehash of the binary offset used for account_class:
	# dec|pos
	#   1|0 = "user" (normal user- created by automated signup)
	#   2|1 = "paid" (a paying account)
	#   4|2 = "power-user" (friend of the staff)
	#   8|3 = "idle-exempt" (does not get checked for being an idle account)
	#  16|4 = ??
	#  32|5 = "duplicate-exempt"
	#  64|6 = "staff" (staff member)
	# 128|7 = "system" (system account - like nobody or qmailr)
	# 256|8 = "root" (may not be necessary, but who knows?)
	# 
	# In the conditions below, return the number one-higher than
	#  the array index. reason being, index 0 points to bit 1.
	#  comprende?
	#

	if ($acct_bits[8]) {
		# root. We should log this. ack.
		return 0;
	} elseif ($acct_bits[7]) {
		# system. We should log this too. less ack.
		return 0;
	} elseif ($acct_bits[6]) {
		# Cool - we got a staff member.
		return 7;
	} elseif ($acct_bits[1]) {
		# Looks like a paid user.
		return 2;
	} elseif ($acct_bits[0]) {
		# Looks like a free user.
		return 1;
	} else {
		# these people have no permissions? shrug.
		return 0;
	}
# End function.
}

function verbose_acctclass($account_class) {
	$acct_bin = decbin($account_class);

	while (strlen($acct_bin) < 9) {
		$acct_bin = "0".$acct_bin;
	}

	# There are only 9 bits in this binary number split into 9 
	# fields.
	$n = 0;
	while (strlen($acct_bin)) {
		$acct_rbits[$n] = intval(substr($acct_bin,0,1));		
		$acct_bin = substr($acct_bin,1);
		$n++;
	}

	# Play an endian game and reverse the order of this array.
	$acct_bits = array_reverse($acct_rbits);

	# A quick rehash of the binary offset used for account_class:
	# dec|pos
	#   1|0 = "user" (normal user- created by automated signup)
	#   2|1 = "paid" (a paying account)
	#   4|2 = "power-user" (friend of the staff)
	#   8|3 = "idle-exempt" (does not get checked for being an idle account)
	#  16|4 = ??
	#  32|5 = "duplicate-exempt"
	#  64|6 = "staff" (staff member)
	# 128|7 = "system" (system account - like nobody or qmailr)
	# 256|8 = "root" (may not be necessary, but who knows?)
	# 
	# In the conditions below, return the number one-higher than
	#  the array index. reason being, index 0 points to bit 1.
	#  comprende?
	#

	if ($acct_bits[8]) {
		# root.
		$outmsg .= "root,";
	} 
	if ($acct_bits[7]) {
		# system account.
		$outmsg .= "system,";
	}
	if ($acct_bits[6]) {
		# staff member
		$outmsg .= "staff,";
	}
	if ($acct_bits[5]) {
		# Unused 2
		$outmsg .= "duplicate-ok,";
	}
	if ($acct_bits[4]) {
		# Unused 1
		$outmsg .= "unused,";
	}
	if ($acct_bits[3]) {
		# idle-exempt
		$outmsg .= "idle-exempt,";
	}
	if ($acct_bits[2]) {
		# power-user
		$outmsg .= "power-user,";
	}
	if ($acct_bits[1]) {
		# Looks like a paid user.
		$outmsg .= "paid,";
	}
	if ($acct_bits[0]) {
		# Looks like a free user.
		$outmsg .= "user,";
	}
	$outmsg = substr($outmsg,0,strlen($outmsg) - 1);
	return $outmsg;

# End function.
}


function is_idle_exempt($username) {
	$inc_dbh = db_connect();
	$db_query = "SELECT account_class FROM users WHERE username = '$username'";
	$inc_sth = pg_query($inc_dbh,$db_query);
	if (pg_numrows($inc_sth) != 1) {
		return 0;
	}
	$result = pg_fetch_row($inc_sth,0);
	$account_class = $result[0];
#echo "DEBUG: Account class found for $username is $account_class<br>\n";
#	pg_close($inc_dbh);

	$acct_bin = decbin($account_class);

	while (strlen($acct_bin) < 9) {
		$acct_bin = "0".$acct_bin;
	}

	# There are only 9 bits in this binary number split into 9 
	# fields.
	$n = 0;
	while (strlen($acct_bin)) {
		$acct_rbits[$n] = intval(substr($acct_bin,0,1));		
		$acct_bin = substr($acct_bin,1);
		$n++;
	}

	# Play an endian game and reverse the order of this array.
	$acct_bits = array_reverse($acct_rbits);

	if ($acct_bits[3]) {
		return 1;
	}
	return 0;
}
?>
