<?
###
# Feature Management functions.
###

function get_features($user) {
	# If run with no user, returns default (available) features.
	# If run with a user, returns only their configured features.
	# If run with a non-existent user, returns -1.

	$inc_dbh = db_connect();
	$features = array();

	if (isset($user)) {
		$db_query = "SELECT username FROM users WHERE username = '$user'";
		$sth = pg_query($inc_dbh,$db_query);
		$numrows = pg_numrows($sth);
		if ($numrows <= 0) {
			# Failed to find user.
			return -1;
		}
		$db_query = "SELECT feature,enabled,config,cost FROM features WHERE username = '$user'";
		$sth = pg_query($inc_dbh,$db_query);
		$numrows = pg_numrows($sth);
	
		for ($n = 0;$n < $numrows;$n++) {
			$db_row = pg_fetch_row($sth,$n);
			$features[$db_row[0]][enabled] = $db_row[1];
			$features[$db_row[0]][config] = $db_row[2];
			$features[$db_row[0]][cost] = $db_row[3];
		} #End for
	} else {
		$db_query = "SELECT feature,enabled,user_configurable,config,cost FROM features_default";
		$sth = pg_query($inc_dbh,$db_query);
		$numrows = pg_numrows($sth);

		for ($n = 0;$n < $numrows;$n++) {
			$db_row = pg_fetch_row($sth,$n);
			$features[$db_row[0]][enabled] = $db_row[1];
			$features[$db_row[0]][user_configurable] = $db_row[2];
			$features[$db_row[0]][config] = $db_row[3];
			$features[$db_row[0]][cost] = $db_row[4];
		} #End for
	}
	return $features;
} #End function get_features.

function set_features($user,$assignedby,$features) {
	if (!isset($user)) {
		return -1;
	}
	$features_old = get_features();
	$features_user = get_features($user);
	foreach ($features_user as $key => $value) {
		foreach ($value as $akey => $aval) {
			$features_old[$key][$akey] = $aval;
		}
	}
	$features_changed = array_xdiff_assoc($features,$features_old);

	$date = time();
	foreach ($features_changed as $feat => $feat_array) {
#		foreach ($feat_array as $akey => $aval) {
#			echo "$feat: $akey => $aval<br>\n";
#		}
		$command = "enabled=$feat_array[enabled],config=$feat_array[config],cost=$feat_array[cost]";
		if (!add_task($user,$assignedby,$date,"feature-$feat","$command")) {
			return -1;
		}
	} #End foreach

	# Upon success, return $features_changed to let the program know what
	#  is changing.
	return $features_changed;
}

?>
